package com.sky.ioc.mapper.carbon;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.sky.ioc.entity.domain.carbon.CarCarbon;
import com.sky.ioc.entity.params.IocParam;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

@Mapper
public interface CarCarbonMapper extends BaseMapper<CarCarbon> {

    @Select("<script> " +
            "select coalesce(sum(discharge),0) from car_carbon where  1=1 " +
            "<if test='iocParam!=null and iocParam.timeRange!=null '>" +
            "and time between #{iocParam.timeRange.startDate} and #{iocParam.timeRange.endDate} " +
            "</if>" +
            "<if test='iocParam!=null and iocParam.deptId!=null '>" +
            "and dept_id = #{iocParam.deptId} " +
            "</if>" +
            "</script>")
    long getDischargeByTime(@Param("iocParam")IocParam iocParam);

    @Select("<script> " +
            "select coalesce(sum(discharge),0) from car_carbon where  1=1 " +
            "<if test='iocParam!=null and iocParam.timeRange!=null '>" +
            "and time between #{iocParam.timeRange.startDate} and #{iocParam.timeRange.endDate} " +
            "</if>" +
            "<if test='iocParam!=null and iocParam.deptId!=null '>" +
            "and dept_id = #{iocParam.deptId} " +
            "</if>" +
            "</script>")
    long getMileageByTime(@Param("iocParam")IocParam iocParam);

    @Select("<script> " +
            "select coalesce(sum(hours),0) from car_carbon where  1=1 " +
            "<if test='iocParam!=null and iocParam.timeRange!=null '>" +
            "and time between #{iocParam.timeRange.startDate} and #{iocParam.timeRange.endDate} " +
            "</if>" +
            "<if test='iocParam!=null and iocParam.deptId!=null '>" +
            "and dept_id = #{iocParam.deptId} " +
            "</if>" +
            "</script>")
    long getHoursByTime(@Param("iocParam")IocParam iocParam);

}
